//=================================
// include guard
#pragma once

//=================================
// included dependencies
#include "fitnessfunctionHW.h"
#include <armadillo>

#include "..\Hybrid_functions\hyb_functions.h"

//=================================
// namespaces
using namespace std;
using namespace arma;

//=================================
// the HydroWind class
class HydroWind : public HWfitnessfunction
{
public:
	//=================================
	HydroWind():HWfitnessfunction(){ }; // constructor
	
	//=================================
	double calcFitness(
		const fvec &variaveisProblema,  
		const vec &typeperiodEntry, 
		const vec &windgenEntry, 
		vector<double> Pos, 
		vec xanterior, 
		vec xfinal
		)
	{
		vec typeperiod = typeperiodEntry;
		vec windgen = windgenEntry;

		unsigned int DimIn = Pos.size(); // dimension of search space
		double p=0.0;
		double h=0.0, h1=0.0, h2=0.0, eturb=0.0, epump=0.0, Hg=0.0, Hpw=0.0, Hpr=0.0, Wp=0.0, Ws=0.0;
		//declarao de variveis

		float  kturb = variaveisProblema(0);
		float  kpump = variaveisProblema(1);
		float  PHg1 = variaveisProblema(2);
		float  PHg0 = variaveisProblema(3);
		float  PGp1 = variaveisProblema(4);
		float  PGp0 = variaveisProblema(5);
		float  PHpw1 = variaveisProblema(6);
		float  PHpw0 = variaveisProblema(7);
		float  PWp1 = variaveisProblema(8);
		float  PWp0 = variaveisProblema(9);
		float  PWs1 = variaveisProblema(10);
		float  PWs0 = variaveisProblema(11);
		float numR = variaveisProblema(12);
		float temp = variaveisProblema(13);
		


		double fit = HYB_func::ReturnFit (
				Pos,
				variaveisProblema,
				typeperiodEntry, 
				windgenEntry, 
				xanterior,
				xfinal);

		return (fit);
	}
};
