#include "hyb_functions.h"


double HYB_func::sumOmega_func(
	double location,
	const vec &numres,
	const vec &z, 
	const vector <double> &expPos,
	ProblemSelection ProblemSelect
	)
{
	double sumomega=0.0;

	//construo de sumomega
	
	switch (ProblemSelect)
	{
		case Reservoirs8: 
			{
				switch (static_cast<int>(numres[location]))//static cast because switch can only accept enum or int
				{
					case 1: sumomega=0; break;
					case 2: sumomega=expPos[location-1]+z[location-1]; break;
					case 3: sumomega=expPos[location-1] + z[location-1]; break;
					case 4: sumomega=0; break;
					case 5: sumomega=expPos[location-1] + z[location-1]; break; 
					case 6: sumomega=expPos[location-1]+expPos[location-3]+z[location-1]+z[location-3]; break;
					case 7: sumomega=0; break;
					case 8: sumomega=expPos[location-1]+expPos[location-2]+z[location-1]+z[location-2]; break;
				}
				break;
			}
		case Reservoirs12: 
			{
				switch (static_cast<int>(numres[location]))//static cast because switch can only accept enum or int
				{
					case 1: sumomega= 0; break;    //....OK==
					case 2: sumomega= expPos[location-1] + z[location-1]; break;    //....OK==
					case 3: sumomega= expPos[location-1] + z[location-1]; break;    //....OK==
					case 4: sumomega= 0; break;    //....OK==
					case 5: sumomega= expPos[location-1] + z[location-1]; break;     //....OK==
					case 6: sumomega= expPos[location-1] + expPos[location-3] + z[location-1] + z[location-3]; break;     //....OK==
					case 7: sumomega= 0; break;    //....OK==
					case 8: sumomega= expPos[location-1] + z[location-1]; break;    //....OK
					case 9: sumomega= expPos[location-1] + expPos[location-3] + z[location-1] + z[location-3]; break;     //....OK
					case 10: sumomega= 0; break;     //....OK
					case 11: sumomega= expPos[location-1] + z[location-1]; break;    //....OK
					case 12: sumomega= expPos[location-1] + expPos[location-3] + z[location-1] + z[location-3]; break;     //....OK
				}
				break;
			}
		default: cout << "ERROR!!! ";
	}
	
	
	return (sumomega);

}


double HYB_func::Gama_func(
	double location,
	const vec &numres,
	const vec &xfinal, 
	const vec &capmin,
	ProblemSelection ProblemSelect)
{
	double gama=0.0;
	//gama


	switch (ProblemSelect)
	{
		case Reservoirs8: 
			{
				switch (static_cast<int>(numres[location]))
				{
					case 1: gama=xfinal[location+1]-capmin[location+1]; break;
					case 2: gama=xfinal[location+1]-capmin[location+1]; break;
					case 3: gama=xfinal[location+3]-capmin[location+3]; break;
					case 4: gama=xfinal[location+1]-capmin[location+1]; break;
					case 5: gama=xfinal[location+1]-capmin[location+1]; break; 
					case 6: gama=xfinal[location+2]-capmin[location+2]; break;
					case 7: gama=xfinal[location+1]-capmin[location+1]; break;
					case 8: gama=0; break;
					//default: gama[i]=0;
				}
				break;
			}
		case Reservoirs12: 
			{
				switch (static_cast<int>(numres[location]))
				{
					case 1: gama=xfinal[location+1]-capmin[location+1]; break;    //....OK==
					case 2: gama=xfinal[location+1]-capmin[location+1]; break;    //....OK==
					case 3: gama=xfinal[location+3]-capmin[location+3]; break;    //....OK==
					case 4: gama=xfinal[location+1]-capmin[location+1]; break;    //....OK==
					case 5: gama=xfinal[location+1]-capmin[location+1]; break;     //....OK==
					case 6: gama=xfinal[location+3]-capmin[location+3]; break;    //....OK
					case 7: gama=xfinal[location+1]-capmin[location+1]; break;    //....OK==
					case 8: gama=xfinal[location+1]-capmin[location+1]; break;    //....OK
					case 9: gama=xfinal[location+3]-capmin[location+3]; break;    //....OK
					case 10: gama=xfinal[location+1]-capmin[location+1]; break;    //....OK
					case 11: gama=xfinal[location+1]-capmin[location+1]; break;    //....OK
					case 12: gama=0; break;
					//default: gama[i]=0;
				}
				break;
			}
		default: cout << "ERROR!!! ";
	}

	
	return (gama);
}


void HYB_func::MinMaxPos(
	double &maxPos,
	double &minPos,
	const int &location,
	const vec &xanterior,
	const vector <double> &Pos,
	const vec &capmin,
	const vec &capmax,
	const vec &inflow, 
	const vec &numres, 
	const vec &qmin, 
	const vec &qmax, 
	const double &sumomega,
	const double &gama,
	ProblemSelection ProblemSelect)
{
	
	double aux11, aux22;
	//minPos e maxPos
	aux22=xanterior[location]+inflow[location]+sumomega-capmin[location];
	maxPos=max(min(max(aux22,-gama),qmax[location]), (qmin[location]+1));//double

	switch (ProblemSelect)
	{
		case Reservoirs8: 
			{
				if (numres[location]!=5 && numres[location]!=7)
				{
					aux11=xanterior[location]+inflow[location]+sumomega-capmax[location];
					minPos=(min(max((max(aux11,-gama)),qmin[location]), (qmax[location]-1)));
				}
				else 
				{
					if (numres[location]==5 )
					{
						aux11=xanterior[location]+inflow[location]+sumomega-capmax[location];
						minPos=(min(max((max((aux11),-(gama+Pos[location-2]))),qmin[location]),(qmax[location]-1)));
					}
					if (numres[location]==7 ) 
					{
						aux11=xanterior[location]+inflow[location]+sumomega-capmax[location];
						minPos=(min(max((max((aux11),-(gama+Pos[location-1]))),qmin[location]), (qmax[location]-1)));
					}
				}
				break;
			}
		case Reservoirs12: 
			{
				if (numres[location]!=5 && numres[location]!=8 && numres[location]!=11)
				{
					aux11=xanterior[location]+inflow[location]+sumomega-capmax[location];
					minPos=(min(max((max(aux11,-gama)),qmin[location]), (qmax[location]-1)));
				}
				else 
				{
					if (numres[location]==5 )
					{
						aux11=xanterior[location]+inflow[location]+sumomega-capmax[location];
						minPos=(min(max((max((aux11),-(gama+Pos[location-2]))),qmin[location]),(qmax[location]-1)));
					}
					if (numres[location]==8 ) 
					{
						aux11=xanterior[location]+inflow[location]+sumomega-capmax[location];
						minPos=(min(max((max((aux11),-(gama+Pos[location-2]))),qmin[location]), (qmax[location]-1)));
					}
					if (numres[location]==11 ) 
					{
						aux11=xanterior[location]+inflow[location]+sumomega-capmax[location];
						minPos=(min(max((max((aux11),-(gama+Pos[location-2]))),qmin[location]), (qmax[location]-1)));
					}
				}
				break;
			}
		default: cout << "ERROR!!! ";
	}
	
	return;
}

double HYB_func::ReturnFit (
	vector <double> Pos,
	const fvec &variaveisProblema,
	const vec &typeperiodEntry, 
	const vec &windgenEntry, 
	vec xanterior,
	vec xfinal
	)
{
	vec typeperiod = typeperiodEntry;
	vec windgen = windgenEntry;

	double h=0.0, h1=0.0, h2=0.0, eturb=0.0, epump=0.0, Hg=0.0, Hpw=0.0, Hpr=0.0, Wp=0.0, Ws=0.0;
	double fit=0.0, p=0.0;

	float  kturb = variaveisProblema(0);
	float  kpump = variaveisProblema(1);
	float  PHg1 = variaveisProblema(2);
	float  PHg0 = variaveisProblema(3);
	float  PGp1 = variaveisProblema(4);
	float  PGp0 = variaveisProblema(5);
	float  PHpw1 = variaveisProblema(6);
	float  PHpw0 = variaveisProblema(7);
	float  PWp1 = variaveisProblema(8);
	float  PWp0 = variaveisProblema(9);
	float  PWs1 = variaveisProblema(10);
	float  PWs0 = variaveisProblema(11);
	float numR = variaveisProblema(12);
	float temp = variaveisProblema(13);
	unsigned int DimIn=temp*numR;


	for (unsigned int i=0;i<DimIn;i++)
	{
		h1=pow(((3*(fabs(xanterior[i])))/9.82),0.3333); //h1 inicial em m
		h2=pow(((3*(fabs(xfinal[i+numR])))/9.82),0.3333); //h2 final em m
		h=(h1+h2)/2; //h medio em m, assumindo que a quota de queda tem o valor de referencia de zero
							
		if (Pos[i]>0) //turbinar
		{
			eturb= (kturb * h * Pos[i])/1000; //calcula a energia gerada em KW
			if (typeperiod[i] == 1) 
			{ 
				Hg = PHg1*eturb;
			} //calculo de HgPg atendendo ao peak
			else 
			{
				Hg = PHg0*eturb;
			}
			if (((i+1)%8 != 0) && i!=(DimIn-1)) 
			{
				windgen[i+1] = windgen[i];
			} //atualiza  o da EED
				
		}
		else //bombar (X[i]<=0)
		{
			epump= (kpump * h * fabs(Pos[i]))/1000; //calcula a energia necess ria para bombar em KW
			if (windgen[i] >= epump) //se a EED>EEN  energia eolica disponivel EED e energia eolica necessaria
			{
				if (typeperiod[i] == 1) 
				{ 
					Wp = PWp1*epump; Hpw = PHpw1*epump;///????
				} //calculo de WpPp atendendo ao peak
				else 
				{
					Wp = PWp0*epump; Hpw = PHpw0*epump;///????
				}
					
				if (((i+1)%8 != 0) && i!=(DimIn-1)) 
				{
					windgen[i+1] = windgen[i]-epump;
				}
				if (i>0 && (i+1)%8 == 0) 
				{
					windgen[i] = windgen[i]-epump;
				}
			} //na posicao windgen[(8i)-1] fica guardado o valor da energia eolica que n foi usada para bombar,
				//logo a EE que sobra no final do tempo i para vender a rede
			else //EED<EEN (windgen[i] < epump)
			{
				if (typeperiod[i] == 1)
				{
					Wp = windgen[i]*PWp1; Hpw = windgen[i]*PWp1; Hpr = (epump - windgen[i])*PGp1;
				} //calculo de WpPp atendendo ao peak
				else
				{
					Wp = windgen[i]*PWp0; Hpw = windgen[i]*PWp0; Hpr = (epump - windgen[i])*PGp0;
				} //N o se atualizou o windgen pq j  estava nulo nas posi  es que devem ser valor zero
				windgen[i] = 0;
			}
		}
		if (i>0 && (i+1)%8 == 0)
		{
			if (typeperiod[i] == 1) 
			{
				Ws = PWs1*windgen[i];
			} //wind energy sellinh price off peak = 7
			else 
			{
				Ws = PWs0*windgen[i];
			}
		}
			
		fit = fit + (Hg - Hpw - Hpr + Wp + Ws); // Euros considerando KILOWATTS
		eturb=0.0; epump=0.0; Hg=0.0; Hpw=0.0; Hpr=0.0; Wp=0.0; Ws=0.0;
	}
		
	return (fit);
}