//=================================
// include guard
#pragma once

//=================================
// included dependencies
#include <vector>
#include <armadillo>
#include <iostream>
#include <string>

#include "..\enumerations.h"

//=================================
// namespaces
using namespace std;
using namespace arma;

class HYB_func
{
public:

	static double sumOmega_func
		(double location,
		const vec &numres, 
		const vec &z, 
		const vector <double> &expPos,
		ProblemSelection ProblemSelect);
	//sumomega= adder of the water released and/or spilled from the immediatly upstream reservoirs
	//z=amount of water spilled out of the reservoir


	static double Gama_func
		(double location,
		const vec &numres,
		const vec &xfinal, 
		const vec &capmin,
		ProblemSelection ProblemSelect);
	//gama= maximun water that can be pumped from the immediatly downstream reservoir


	static void MinMaxPos(
		double &maxPos,
		double &minPos,
		const int &location,
		const vec &xanterior,
		const vector <double> &Pos,
		const vec &capmin,
		const vec &capmax,
		const vec &inflow, 
		const vec &numres, 
		const vec &qmin, 
		const vec &qmax, 
		const double &sumomega,
		const double &gama,
		ProblemSelection ProblemSelect);


	static double HYB_func::ReturnFit (
			vector <double> Pos,
			const fvec &variaveisProblema,
			const vec &typeperiodEntry, 
			const vec &windgenEntry, 
			vec xanterior,
			vec xfinal);
			

};
