//=================================
// include guard
#pragma once


//=================================
// included dependencies
/*
#include <iostream>
#include <math.h>
#include <stdio.h>
#include <fstream>
#include <string>
#include <vector>
#include <sstream>
#include <stdlib.h>
#include <boost/random.hpp>*/
#include <armadillo> //matrices
#include "..\ITL_networks\General_Functions.h"
//boost libraries
#include "..\enumerations.h"

//=================================
// namespaces
//using namespace std;
//using namespace arma;

class Normalization
{
public:
	//=================================
	static rowvec Parameter1_function (
		const mat &TrainSet,  
		const NormalizationMethod &NormMethod, 
		const unsigned short &DimIn);

	//=================================
	static rowvec Parameter2_function (
		const mat &TrainSet,  
		const NormalizationMethod &NormMethod, 
		const unsigned short &DimIn);

	//=================================
	static mat EntranceNormalizationMinMax (
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const mat &notNormalized, 
		const rowvec &MaxTrain, 
		const rowvec &MinTrain);

	//=================================
	static mat EntranceNormalizationZScore (
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const mat &notNormalized, 
		const rowvec &MeanTrain, 
		const rowvec &SDevTrain);

	//=================================
	static mat GlobalNormalizationMinMax (
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const mat &notNormalized, 
		const rowvec &MaxTrain, 
		const rowvec &MinTrain);

	//=================================
	static mat GlobalNormalizationZScore (
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const mat &notNormalized, 
		const rowvec &MeanTrain, 
		const rowvec &SDevTrain);

	//=================================
	static mat  Normalization_function (
		const rowvec &P1, 
		const rowvec &P2, 
		const mat &notNormalized, 
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const NormalizationMethod &NormMethod);


	//=================================
	static mat ReadAndNorm_function (
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const string &Filename, 
		const rowvec &MaxTrain, 
		const rowvec &MinTrain, 
		const NormalizationMethod &NormMethod);

	//=================================
	static mat GlobalDESNormalizationMinMax (
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const mat &Normalized, 
		const rowvec &MaxTrain, 
		const rowvec &MinTrain);


	//=================================
	static mat EntranceDESNormalizationMinMax (
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const mat &Normalized, 
		const rowvec &MaxTrain, 
		const rowvec &MinTrain);

	//=================================
	static mat EntranceDESNormalizationZScore (
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const mat &Normalized, 
		const rowvec &MeanTrain, 
		const rowvec &SDevTrain);

	//=================================
	static mat GlobalDESNormalizationZScore (
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const mat &Normalized, 
		const rowvec &MeanTrain, 
		const rowvec &SDevTrain);


	//=================================
	static mat  DES_Normalization_function (
		const rowvec &P1, 
		const rowvec &P2, 
		const mat &Normalized, 
		const unsigned short &linhas, 
		const unsigned short &colunas, 
		const NormalizationMethod &NormMethod);
};
